#!/usr/bin/env python

"""
http://www.python.org/pypi/BitDecoder/0.5.1
"""

def printBin(val):
    mask = 1
    print ("%x: " %val),
    #s = str('')
    indicies = range(32)
    indicies.reverse()
    for i in indicies:
        newVal = (val >> i) & mask
        print newVal,
    print

import struct
def convert64(ibm_float):
    i = struct.unpack('>I',ibm_float)[0]
    sign = [1,-1][bool(i & 0x100000000L)]
    characteristic = ((i >> 24) & 0x7f) - 64
    fraction = (i & 0xffffff)/float(0x1000000L)
    return sign*16**characteristic*fraction

def convert32(ibm_float):
    i = struct.unpack('>i',ibm_float)[0]
    sign = [1,-1][bool(i & 0x100000000L)]
    characteristic = ((i >> 24) & 0x7f) - 64
    fraction = (i & 0xffffff)/float(0x1000000L)
    return sign*16**characteristic*fraction



if __name__ == "__main__":

    hexVal = 0xC2B19FAF
    floatVal = -177.6237604
    hexStr = "\xC2\xB1\x9F\xAF"
    #printBin(hexVal)
    #print hexVal, floatVal
    #print ("%x" % hexVal )

    sign = hexVal >> 31
    print "sign = ",sign

    # 30-24
    printBin(0x1|0x2|0x4|0x8 | 0x16|0x32|0x64)
    exponent = (hexVal >> 24) & 0x7f
    printBin(exponent)
    print "exp = ",exponent

    printBin(0xffffff)
    fraction = hexVal & 0xffffff

    printBin(fraction)
    print "frc = ",fraction

    ##############################

    print "len = ",len(hexStr), hexStr
    print "conv = ",convert32(hexStr)

