#!/usr/bin/env python
from segy import Segy
import segy
import sqlite
import os
import sys

from optparse import OptionParser

# What version do we want to track?  This would be for cvs of this file
vcvs = "$Revision: 1.7 $"
vcvs = vcvs[vcvs.find(':')+2:]
vcvs = vcvs[:vcvs.find('$')-1]
version_cvs = vcvs
del (vcvs) # stop polution

# Track the version of segy-py.  If I use setup.py, which one gets imported?
from segy_version import VERSION

myparser = OptionParser(usage="$prog [options] segyfile1 segyfile2 ... segyfileN",
                      version="%prog "+VERSION+' - '+version_cvs)
myparser.add_option('-c','--create',dest='create',action="store_true",default=True,
		    help='create the tables for segyFile and segyTrace')
myparser.add_option('-C','--no-create',dest='create',action='store_false',
		    help='do NOT create the tables.  Assume that they have already been created')
myparser.add_option('-d','--driver',dest="drv",
                  help="specify which driver to parse data file.  [default: %default]",
                  default="segy_drv_rev1")
myparser.add_option('-D','--delete',dest='delete',default=False,action='store_true',
		    help='delete previous db if it exists  [default: %default]')
myparser.add_option('-f','--file',dest='dbfilename',default='segy.db',
		    help='file for the sqlite database  [default: %default]')
myparser.add_option('-s','--shortList',dest='short', default=False, action='store_true',
		    help='use short list for keys to use [default: %default]')


if __name__ == "__main__":
        (options,args) = myparser.parse_args()
	dbName = options.dbfilename
	if options.delete and os.access(dbName,os.W_OK):
            os.remove(dbName)
	cx = sqlite.connect(dbName)
	cu = cx.cursor()

	#
	# CREATE the database tables
	#
	if options.create:
		if options.short:
			import imp
			driverFile = open(options.drv+'.py','r')
			drv = imp.load_module(options.drv,driverFile,options.drv+'.py',('.py','r',imp.PY_SOURCE))

			cu.execute(segy.sqlCreateFileTable(drivername='segy_drv_xstar',specificKeys=drv.fileHeaderShortList))
			cu.execute(segy.sqlCreateTraceTable(drivername='segy_drv_xstar',specificKeys=drv.traceHeaderShortList))
		else:
			cu.execute(segy.sqlCreateFileTable(drivername='segy_drv_xstar'))
			cu.execute(segy.sqlCreateTraceTable(drivername='segy_drv_xstar'))
		cx.commit()

	#
	# POPULATE the tables
	#
	#[ 'bpsio01L00.xstar',  'bpsio04L03.xstar']:
	for filename in args:
		xstar = Segy(filename,drivername=options.drv)
		if options.short:
			cu.execute(xstar.header.sqlInsert(filename=filename,specificKeys=xstar.drv.fileHeaderShortList))
		else:
			cu.execute(xstar.header.sqlInsert(filename=filename))
		cx.commit()

		cu.execute('SELECT fileKey FROM segyFile WHERE filename=\''+filename+'\'')
		fileKey = cu.fetchone()['fileKey']
		print 'fileKey = ',fileKey
		
		for i in range(1,xstar.getNumberOfTraces()):
			t = xstar.getTraceHdr(i)
			if i>2000: break  # FIX: remove this hack

			if 0==i%500:
				traceNo = t.getHeader('TraceNo')
				x = t.getHeader('X')/3600.
				y = t.getHeader('Y')/3600.
				print i,':   ',traceNo, x,y
	
			cu.execute(t.sqlInsert(specificKeys=xstar.drv.traceHeaderShortList,traceNumber=i,fileKey=fileKey))
		cx.commit()	# Flush this to the db!

	
